
#include <18F4620.h>
#device adc=8
#fuses INTRC_IO,NOWDT,NOPROTECT,NOLVP
#use delay(clock=32M)
#use rs232(baud=115200, xmit=PIN_C6, rcv=PIN_C7) 
#define GLCD_WIDTH   128

#define asagi  0
#define saga   1
#define sola   2
#define yukari 3

#define TONE_PIN  PIN_A3
#define SPEECH_PIN PIN_A3


#define GLCD_E       PIN_A5   // Enable
#define GLCD_DI      PIN_A2
#define GLCD_CS1     PIN_A0   // Chip Selection 1
#define GLCD_CS2     PIN_A1
#define GLCD_RW      PIN_A4   // Read/Write

#define FAST_GLCD

#include <HDM64GS12.c>
#include <graphics.c>
#include <math.h>


#INCLUDE <STDLIB.H> 

   
#include "splashscreen.h"


/*#include "hey_converted_1_1.c"
#include "hamm_converted_1_1.c"
#include "ayy_converted_1_1.c"
#include "rattlesnake_1_1_converted.C"
*/
typedef struct 
{ 
   int x[60]; 
   int y[60]; 
   int head: 6;      
   int dir: 2;
   int lives ;
   int length ;
   int16 score;
} yilanveri;
    
yilanveri yilan1;
yilanveri yilan2;
  
   char  geym[] = "game"  ;
   char  ovir[] = "over"  ;
   
int oncekitus1, basilantus1,tusdeger1;
int oncekitus2, basilantus2,tusdeger2;
int oncekitus3, basilantus3,tusdeger3;   
  
void beep(int16 period){

   while((period--) != 0)
   {
      output_high(TONE_PIN);
      delay_ms(1);
      output_low(TONE_PIN);
      delay_ms(1);
   }
} 

void click(int gidisyonu){
      output_high(TONE_PIN);
      delay_us(gidisyonu*5);
      output_low(TONE_PIN);
      delay_us(gidisyonu*5);
}
  
  
void ciuv(int period, int saysur){
int sayper;
int sayac;
sayper = period;
 while((sayper--) != 0)
 {
      for(sayac=1;sayac<saysur;sayac++)
      {
      output_high(TONE_PIN);
      delay_us(sayac);
      delay_us(sayac);
      output_low(TONE_PIN);
      delay_us(sayac);
      delay_us(sayac);
      }
 }
}  





/*

void sayhey() 

{ 

int16 i; 
int8 c; 
int8 currentbit; 
int1 prevbit;
int1 bosluk;

enbas:
c = sound_data[i]; 


for (i=0; i<1785; i++){  //Go through the sound_data array 
c = sound_data[i]; 
//***********************Read bitwise 
               for (currentbit = 0; currentbit < 8; currentbit++){ 
                  if(  bit_test(c,currentbit)  ){  //If the bit is a 1. 
                     if ( prevbit == 1 ) output_high(SPEECH_PIN);
                     else bosluk = input ( SPEECH_PIN );
                     prevbit =  1;
                  }else{                                //If the bit is a 0. 
                     if ( prevbit == 0 ) output_low(SPEECH_PIN);
                     else bosluk = input ( SPEECH_PIN );
                     prevbit =  0;
                  } 
                  delay_us(20); 
               } 
//**********************Read bitwise 
}

} 


void sayham() 

{ 


int16 i; 
int8 c; 
int8 currentbit; 
int1 prevbit;
int1 bosluk;

enbas:
c = sound_data[i]; 


for (i=0; i<3825; i++){  //Go through the sound_data array 
c = sound_data2[i]; 
//***********************Read bitwise 
               for (currentbit = 0; currentbit < 8; currentbit++){ 
                  if(  bit_test(c,currentbit)  ){  //If the bit is a 1. 
                     if ( prevbit == 1 ) output_high(SPEECH_PIN);
                     else bosluk = input ( SPEECH_PIN );
                     prevbit =  1;
                  }else{                                //If the bit is a 0. 
                     if ( prevbit == 0 ) output_low(SPEECH_PIN);
                     else bosluk = input ( SPEECH_PIN );
                     prevbit =  0;
                  } 
                  delay_us(20); 
               } 
//**********************Read bitwise 
}

} 


void sayayy() 

{ 


int16 i; 
int8 c; 
int8 currentbit; 
int1 prevbit;
int1 bosluk;

enbas:
c = sound_data[i]; 


for (i=0; i<3825; i++){  //Go through the sound_data array 
c = sound_data3[i]; 
//***********************Read bitwise 
               for (currentbit = 0; currentbit < 8; currentbit++){ 
                  if(  bit_test(c,currentbit)  ){  //If the bit is a 1. 
                     if ( prevbit == 1 ) output_high(SPEECH_PIN);
                     else bosluk = input ( SPEECH_PIN );
                     prevbit =  1;
                  }else{                                //If the bit is a 0. 
                     if ( prevbit == 0 ) output_low(SPEECH_PIN);
                     else bosluk = input ( SPEECH_PIN );
                     prevbit =  0;
                  } 
                  delay_us(20); 
               }  
//**********************Read bitwise 
}

} 


void sayrattle(int tekrar) 

{ 

int16 i;
int8 c; 
int8 currentbit; 
int1 prevbit;
int1 bosluk;

enbas:
//c = sound_data4[i]; 

while ( tekrar > 0 ) {
for (i=0; i<912; i++){  //Go through the sound_data array 
c = sound_data4[i]; 
//***********************Read bitwise 
               for (currentbit = 0; currentbit < 8; currentbit++){ 
                  if(  bit_test(c,currentbit)  ){  //If the bit is a 1. 
                     if ( prevbit == 1 ) output_high(SPEECH_PIN);
                     else bosluk = input ( SPEECH_PIN );
                     prevbit =  1;
                  }else{                                //If the bit is a 0. 
                     if ( prevbit == 0 ) output_low(SPEECH_PIN);
                     else bosluk = input ( SPEECH_PIN );
                     prevbit =  0;
                  } 
                  delay_us(20); 
               } 
//**********************Read bitwise 
}
tekrar--;
delay_ms(10);
}
} 

*/


void splashscreen(int xs, int ys)
{

int i, j, k;
int16 sayac2=0 ;

int width = 128;
int height = 64;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(snake[sayac2],k)){
               glcd_pixel(xs+j,ys+i+k,ON); 
               }
      }
      sayac2++;
   }
}
}

void gamescreen(int xs, int ys)
{

int i, j, k;
int16 sayac2=0 ;

int width = 128;
int height = 64;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(game[sayac2],k)){
               glcd_pixel(xs+j,ys+i+k,ON); 
               }
      }
      sayac2++;
   }
}
}

void lifekill(){


   
      if (yilan1.lives==2)   glcd_circle(19,16,1,1,1);
      if (yilan1.lives==1) { glcd_circle(19,16,1,1,1);glcd_circle(19,26,1,1,1);}
      if (yilan1.lives==0) { glcd_circle(19,16,1,1,1);glcd_circle(19,26,1,1,1);glcd_circle(19,36,1,1,1);}
   
      if (yilan2.lives==2)   glcd_circle(108,16,1,1,1);
      if (yilan2.lives==1) { glcd_circle(108,16,1,1,1);glcd_circle(108,26,1,1,1);  }
      if (yilan2.lives==0) { glcd_circle(108,16,1,1,1);glcd_circle(108,26,1,1,1); glcd_circle(108,36,1,1,1);}
   
   
   /*glcd_circle(19,16,1,1,1);
   glcd_circle(19,26,1,1,1);
   glcd_circle(19,36,1,1,1);

   glcd_circle(108,16,1,1,1);
   glcd_circle(108,26,1,1,1);
   glcd_circle(108,36,1,1,1);*/

}


//-------------------------{}----------------------------
void tusbak(){

output_e (0b101);
delay_ms(5);
basilantus1 = input_b() | 0b11100000;
tusdeger1 = basilantus1; 
//if(tusdeger1!=255)beep(4);
output_e (0b110);
delay_ms(5);
basilantus2 = input_b() | 0b11100000;
tusdeger2 = basilantus2; 
//if(tusdeger2!=255)beep(4);
output_e (0b011);
delay_ms(5);
basilantus3 = input_b() | 0b11100000;
tusdeger3 = basilantus3; 
//if(tusdeger3!=255)beep(4);
   
printf("\f(%u) (%u) (%u)", tusdeger1, tusdeger2, tusdeger3); 
}
//-------------------------{}----------------------------

void main() {



   int16 yavaslat1, yavaslat2, randrand;
   int32 splashbekle;
   int  sayac, randx=200, randy=200, dotx, doty ;
   int1  soltusbirak = 1, sagtusbirak = 1;
   int1  soltusbirak2 = 1, sagtusbirak2 = 1;
   int1  twoplayer;

   setup_adc_ports(NO_ANALOGS);
   setup_psp(PSP_DISABLED);
   setup_oscillator(OSC_32MHZ | OSC_PLL_ON);   
   setup_comparator(NC_NC_NC_NC);   

   
   port_b_pullups( TRUE );

   
   
   printf(" Ozkal's Micro Snake (%s) (%s )\n\r",__FILENAME__,__DATE__); 
   randrand = 29;
   srand(randrand);
   
   
   
   //ciuv(1,200);
   click(1);
   
   
enbas:  

   yilan1.dir = asagi;
   yilan1.x [0] = 30 ;
   yilan1.y [0] = 30 ;
   yilan1.lives = 3;
   yilan1.length = 10 ;
   for (sayac=1 ; sayac <= yilan1.length ; sayac++) { 
      yilan1.x [ sayac ] = 30 ;
      yilan1.y [ sayac ] = 30 ;   
   }
   
   yilan2.dir = yukari;
   yilan2.x [0] = 95 ;
   yilan2.y [0] = 30 ;
   yilan2.lives = 3;
   yilan2.length = 10 ;
   for (sayac=1 ; sayac <= yilan2.length ; sayac++) { 
      yilan2.x [ sayac ] = 95 ;
      yilan2.y [ sayac ] = 30 ;   
   }
   

   printf("Snake1:%u Snake2: %u lives.\n\r", yilan1.lives, yilan2.lives);
   glcd_init(ON);
   
   
   splashscreen(0,0);   
   glcd_update();
   
   //sayhey();
   
   
   splashbekle=500000;
   
   twoplayer=0;
   
   /*
   while(TRUE){
      tusbak();
      if ( tusdeger2 == 254 ) { twoplayer = 0; sayhey();          goto oyunbas; }
      if ( tusdeger2 == 247 ) { twoplayer = 1; sayhey();sayhey(); goto oyunbas; }
      if ( splashbekle-- == 0 ) { splashbekle = 365500; sayhey();}
   }
   */

oyunbas:   
  

   printf("Twoplayer:%u \n\r", twoplayer );

   glcd_init(ON);

   gamescreen(0,0);
   glcd_update();
   
   delay_ms(250);
   
   lifekill();
   
   delay_ms(250);
   

   //glcd_rect(23, 0,  104, 4 , 1, 1);
   //glcd_rect(23, 7,  104, 56, 0, 1);
   //glcd_rect(23, 59, 104, 63, 1, 1);   
   
      while(randx > 79 || randx < 24 ) randx = rand();
      while(randy > 56 || randy <= 6 ) randy = rand();
      glcd_pixel(randx,randy,1);
      dotx=randx; doty=randy;
      randx=200; randy=200;
      
      yilan1.score=0;
      yilan2.score=0;
//|||||||||||||||||||||||||||||||||| yeni ana  dng |||||||||||||||||||||||||||||||||||

while(TRUE){

if (yavaslat1-- == 0 ){

yavaslat1 = 15000- (int16) yilan1.length*250;

   glcd_pixel(yilan1.x[ yilan1.length ],yilan1.y[ yilan1.length ],0);
   
   glcd_pixel(6, yilan1.y[0],1);
   glcd_pixel(6, yilan1.y[0]-1,0);
   glcd_pixel(6, yilan1.y[0]+1,0);

   for (sayac=yilan1.length ; sayac != 0 ; sayac--) {
      yilan1.x[ sayac ] = yilan1.x[ sayac - 1 ];
      yilan1.y[ sayac ] = yilan1.y[ sayac - 1 ];
   }


   if (yilan1.dir == saga)   yilan1.x[ 0 ] ++;
   if (yilan1.dir == sola)   yilan1.x[ 0 ] --;
   if (yilan1.dir == yukari) yilan1.y[ 0 ] --;
   if (yilan1.dir == asagi)  yilan1.y[ 0 ] ++;  
   
   for (sayac=1 ; sayac <= yilan1.length ; sayac++) { 
      if ( yilan1.x [ sayac ] == yilan1.x [ 0 ] && yilan1.y [ sayac ] == yilan1.y [ 0 ] ) goto death;   
   }
   for (sayac=1 ; sayac <= yilan1.length ; sayac++) { 
      if ( yilan1.x [ sayac ] == yilan2.x [ 0 ] && yilan1.y [ sayac ] == yilan2.y [ 0 ] ) goto death;   
   }
   
   
   tusbak();
   if ( tusdeger3==253 && soltusbirak == 1) {
      soltusbirak = 0;
      beep(5);
      //sayrattle(1) ;
      switch( yilan1.dir ) {
         case saga : yilan1.dir = yukari;
         break;
         case sola : yilan1.dir = asagi;
         break;
         case yukari : yilan1.dir = sola;
         break;
         case asagi : yilan1.dir = saga;
         break;
         }
   }
   if ( tusdeger3!=253 ) soltusbirak = 1;
   tusbak();   
   if (tusdeger3==239 && sagtusbirak == 1) {
      sagtusbirak = 0;
      beep(5);
      //sayrattle(1) ;
      switch( yilan1.dir ) {
         case saga : yilan1.dir = asagi;
         break;
         case sola : yilan1.dir = yukari;
         break;
         case yukari : yilan1.dir = saga;
         break;
         case asagi : yilan1.dir = sola;
         break;
         }
   }
   if ( tusdeger3!=239  ) sagtusbirak = 1;   

   

   if ( yilan1.x[0] == dotx && yilan1.y[0] == doty ){
   
      beep(1);
      if( yilan1.length <= 57 ) { yilan1.length= yilan1.length + 1; 
         //sayham(); }
      printf("LEN1: %u LEN2: %u\n\r", yilan1.length, yilan2.length);
nokbul:      
      while(randx > 79 || randx < 24 ) randx = rand();
      while(randy > 56 || randy <= 6) randy = rand();
      
      for (sayac=yilan1.length ; sayac != 0 ; sayac--) 
      {
         if ( yilan1.x[ sayac ] == randx && yilan1.y[ sayac ] == randy ) {
            randrand++;
            srand(randrand);
            goto nokbul;
         }
      }
      glcd_pixel(randx,randy,1);
      dotx=randx; doty=randy;
      randx=200; randy=200;
   }
}




   
   if (yilan1.x[0] == 23 || yilan1.x[0] == 104 || yilan1.y[0] == 6 || yilan1.y[0] == 57 ) {
death:   
      glcd_circle(yilan1.x[0],yilan1.y[0],3,0,1);
      glcd_rect(14, 8,  16, 10 , 1, 1);
      
      //sayayy();
      //ciuv(30,50);

      yilan1.lives--;
      lifekill();
   

      //printf("LIVES: %u\n\r", yilan1.lives);
      if ( yilan1.lives == 0 ) {
      
         glcd_text57(43, 13, &geym [0] , 2, 1) ;
         glcd_text57(43, 33, &ovir [0] , 2, 1) ;
         splashbekle=500000;
         tusbak();
         /*
         while ( tusdeger2 == 255 ){
            if( splashbekle-- == 0) { sayhey(); splashbekle=1000000; }
            if( splashbekle == 750000) sayham();
            if( splashbekle == 400000) sayayy();
         }
         */
         goto enbas;
      }
      yilan1.length=0;
      yilan2.length=0;
      yilan1.x[0] = 30;
      yilan1.y[0] = 30;
      
      
      if ( yilan1.dir < 4 ) yilan1.dir++;
      else yilan1.dir = 1 ;
      
      goto oyunbas;
   }


   glcd_pixel(yilan1.x[ 0 ],yilan1.y[ 0 ],1);   
   //glcd_rect(yilan1.x[ 0 ]-2, yilan1.y[ 0 ]-2,  yilan1.x[ 0 ]+2, yilan1.y[ 0 ]+2 , 1, 1);
   glcd_update();
}

}

//|||||||||||||||||||||||||||||||||| yeni ana  dng SON||||||||||||||||||||||||||||||||

while(TRUE){

if (yavaslat1-- == 0 ){
  
   yilan1.score= yilan1.score + yilan1.length;
   printf("SCORE1: %lu \n\r", yilan1.score);
    
   click(yilan1.dir);



   
   






////////////////////////////////////////////////////////////////////////////////////   


if(twoplayer == 1 ) {
   
   if (yavaslat2-- == 0 ){

   yavaslat2 = 15000- (int16) yilan2.length*250;
   
   click(yilan2.dir);
   
   yilan2.score= yilan2.score + yilan2.length;
   printf("SCORE2: %lu \n\r", yilan2.score);

   glcd_pixel(yilan2.x[ yilan2.length ],yilan2.y[ yilan2.length ],0);
   
   glcd_pixel(121, yilan2.y[0],1);
   glcd_pixel(121, yilan2.y[0]-1,0);
   glcd_pixel(121, yilan2.y[0]+1,0);

   for (sayac=yilan2.length ; sayac != 0 ; sayac--) {
      yilan2.x[ sayac ] = yilan2.x[ sayac - 1 ];
      yilan2.y[ sayac ] = yilan2.y[ sayac - 1 ];
   }

   if (yilan2.dir == saga)   yilan2.x[ 0 ] ++;
   if (yilan2.dir == sola)   yilan2.x[ 0 ] --;
   if (yilan2.dir == yukari) yilan2.y[ 0 ] --;
   if (yilan2.dir == asagi)  yilan2.y[ 0 ] ++;   
   
   
   for (sayac=1 ; sayac <= yilan2.length ; sayac++) { 
      if ( yilan2.x [ sayac ] == yilan2.x [ 0 ] && yilan2.y [ sayac ] == yilan2.y [ 0 ] ) goto death2;   
   }
   for (sayac=1 ; sayac <= yilan1.length ; sayac++) { 
      if ( yilan1.x [ sayac ] == yilan2.x [ 0 ] && yilan1.y [ sayac ] == yilan2.y [ 0 ] ) goto death2;   
   }
   for (sayac=1 ; sayac <= yilan2.length ; sayac++) { 
      if ( yilan2.x [ sayac ] == yilan1.x [ 0 ] && yilan2.y [ sayac ] == yilan1.y [ 0 ] ) goto death;   
   }
   
   if ( yilan2.x[0] == 23 || yilan2.x[0] == 104 || yilan2.y[0] == 6 || yilan2.y[0] == 57 ) {
death2:   
      glcd_circle(yilan2.x[0],yilan2.y[0],3,0,1);
      glcd_rect(112, 8,  114, 10 , 1, 1);

//      sayayy();
//      ciuv(30,50);
      yilan2.lives--;
      lifekill();

      //printf("LIVES: %u\n\r", yilan1.lives);
      if (  yilan2.lives == 0 ) {
      
         glcd_text57(43, 13, &geym [0] , 2, 1) ;
         glcd_text57(43, 33, &ovir [0] , 2, 1) ;
         splashbekle=500000;
         tusbak();/*
         while ( tusdeger2 == 255 ){
            if( splashbekle-- == 0) { sayhey(); splashbekle=1000000; }
            if( splashbekle == 750000) sayham();
            if( splashbekle == 400000) sayayy();
         }*/
         goto enbas;
      }

      yilan1.length=0;
      yilan2.length=0;
      yilan2.x[0] = 95;
      yilan2.y[0] = 30;
      
      
      if ( yilan2.dir < 4 ) yilan2.dir++;
      else yilan2.dir = 1 ;
      
      goto oyunbas;
   }

   
   if ( yilan2.x[0] == dotx && yilan2.y[0] == doty ){
   
      beep(1);
      if( yilan2.length <= 57 ) { yilan2.length= yilan2.length + 1; 
      //sayham();  
      }
      printf("LEN1: %u LEN2: %u\n\r", yilan1.length, yilan2.length);
nokbul2:      
      while(randx > 79 || randx < 24 ) randx = rand();
      while(randy > 56 || randy <= 6) randy = rand();
      
      for (sayac=yilan2.length ; sayac != 0 ; sayac--) 
      {
         if ( yilan2.x[ sayac ] == randx && yilan2.y[ sayac ] == randy ) {
            randrand++;
            srand(randrand);
            goto nokbul2;
         }
      }
      glcd_pixel(randx,randy,1);
      dotx=randx; doty=randy;
      randx=200; randy=200;
   }   
   

   glcd_pixel(yilan2.x[ 0 ],yilan2.y[ 0 ],1);
}   
}
   //**************************************************************************      
   

   /*
   
   if (soltus2 && soltusbirak2 == 1) {
      soltusbirak2 = 0;
      sayrattle(1) ;
      switch( yilan2.dir ) {
         case saga : yilan2.dir = yukari;
         break;
         case sola : yilan2.dir = asagi;
         break;
         case yukari : yilan2.dir = sola;
         break;
         case asagi : yilan2.dir = saga;
         break;
         }
   }
   if ( !soltus2 ) soltusbirak2 = 1;
   
   if (sagtus2 && sagtusbirak2 == 1) {
      sagtusbirak2 = 0;
      sayrattle(1) ;
      switch( yilan2.dir ) {
         case saga : yilan2.dir = asagi;
         break;
         case sola : yilan2.dir = yukari;
         break;
         case yukari : yilan2.dir = saga;
         break;
         case asagi : yilan2.dir = sola;
         break;
         }
   }
   if ( !sagtus2 ) sagtusbirak2 = 1;*/
}
}
}
